<template>
  <div class="app-container">
    <el-card>
      <div slot="header" class="clearfix">
        <span>机床编号:</span>
        <el-select v-model="machineNumberValue" filterable placeholder="机床编号" size="small" clearable @change="searchTable1()">
          <el-option
            v-for="item in machineNumber"
            :key="item.value"
            :label="item.label"
            :value="item.value">
            <div style="float: left">{{ item.label }}</div>
            <div style="float: right; color: #8492a6; font-size: 13px">{{ item.name }}</div>
          </el-option>
        </el-select>
      </div>
      <el-table :data="tableData1" border size="mini" highlight-current-row style="width: 100%;margin-top: 15px" height="200px">
        <el-table-column label="项目名称" align="center">
          <template slot-scope="scope">
            {{ scope.row.项目名称 }}
          </template>
        </el-table-column>
        <el-table-column label="机床编号" align="center">
          <template slot-scope="scope">
            {{ scope.row.机床图号 }}
          </template>
        </el-table-column>
        <el-table-column label="机床名称" align="center">
          <template slot-scope="scope">
            {{ scope.row.机床名称 }}
          </template>
        </el-table-column>
        <el-table-column label="机床数量" align="center">
          <template slot-scope="scope">
            {{ scope.row.机床数量 }}
          </template>
        </el-table-column>
      </el-table>
    </el-card>
    <el-card>
      <h3 style="margin: 0;text-align: center;">工作计划</h3>
      <el-table :data="tableData2" border size="mini" highlight-current-row style="width: 100%;margin-top: 15px" height="380px">
        <el-table-column label="组号" align="center">
          <template slot-scope="scope">
            {{ scope.row.组号 }}
          </template>
        </el-table-column>
        <el-table-column label="任务名称" align="center">
          <template slot-scope="scope">
            {{ scope.row.任务名称 }}
          </template>
        </el-table-column>
        <el-table-column label="计划工时" align="center">
          <template slot-scope="scope">
            {{ scope.row.计划工时 }}
          </template>
        </el-table-column>
        <el-table-column label="实际工时" align="center">
          <template slot-scope="scope">
            <el-input v-if="scope.row.isEditing" v-model="scope.row.实际工时" size="mini"/>
            <span v-if="!scope.row.isEditing">{{ scope.row.实际工时 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="修补工时" align="center">
          <template slot-scope="scope">
            <el-input v-if="scope.row.isEditing" v-model="scope.row.修补工时" size="mini"/>
            <span v-if="!scope.row.isEditing">{{ scope.row.修补工时 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="开始时间" align="center">
          <template slot-scope="scope">
            {{ scope.row.开始时间 }}
          </template>
        </el-table-column>
        <el-table-column label="结束时间" align="center">
          <template slot-scope="scope">
            {{ scope.row.结束时间 }}
          </template>
        </el-table-column>
        <el-table-column label="备注" align="center">
          <template slot-scope="scope">
            <el-input v-if="scope.row.isEditing" v-model="scope.row.备注" size="mini"/>
            <span v-if="!scope.row.isEditing">{{ scope.row.备注 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="300px" fixed="right">
          <template slot-scope="scope">
            <el-button v-if="!scope.row.isEditing" type="primary" size="small" @click="editTable2(scope.row)">编辑</el-button>
            <el-button v-if="scope.row.isEditing" type="primary" size="small" @click="submitTable2(scope.row)">确定</el-button>
            <el-button v-if="scope.row.isEditing" size="small" @click="cancelTable2(scope.row)">取消</el-button>
            <el-button v-if="scope.row.buttonStatus === 1" type="success" size="small" @click="handlestart_3(scope.row)">开始工作</el-button>
            <el-button v-if="scope.row.buttonStatus === 2" type="danger" size="small" @click="handleend_3(scope.row)">结束工作</el-button>
            <el-button v-if="scope.row.buttonStatus === 3" type="info" size="small" >工作完成</el-button>
            <el-button v-if="scope.row.buttonStatus === 2" plain size="small" @click="handleCancelStart_3(scope.row)">取消开始工作</el-button>
            <el-button v-if="scope.row.buttonStatus === 3" plain size="small" @click="handleCancelEnd_3(scope.row)">取消结束工作</el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-card>
  </div>
</template>

<script>
import { initProject, searchgroup, searchTable1, searchTable2, MachineToolStateUpdate, DebugStatusUpdate, ComponentStateUpdate, submitTable2 } from '@/api/Assembly/PlanExecution'
export default {
  name: 'ColdWorkPlanExecution',
  data() {
    return {
      machineNumberValue: '',
      machineNumber: [],
      tableData1: [],
      tableData2: []
    }
  },
  mounted() {
    this.initProject()
  },
  methods: {
    submitTable2(row) {
      submitTable2(row.备注, row.计划流水号, row.实际工时, row.修补工时).then(res => {
        if (res.data[0].result === '1') {
          this.$message.success('编辑成功')
          row.isEditing = !row.isEditing
        } else {
          this.$message.error('编辑失败')
        }
      })
      console.log(row)
    },
    cancelTable2(row) {
      row.isEditing = !row.isEditing
      row.实际工时 = row.原实际工时
      row.修补工时 = row.原修补工时
      row.备注 = row.原备注
      console.log(row)
    },
    editTable2(row) {
      row.isEditing = !row.isEditing
      row.原实际工时 = row.实际工时
      row.原修补工时 = row.修补工时
      row.原备注 = row.备注
      console.log(row)
    },
    // 取消开始工作
    handleCancelStart_3(row) {
      ComponentStateUpdate(row.计划流水号, 3).then(response => {
        this.searchTable1()
        row.buttonStatus = 1
        // this.searchTable2()
      })
    },
    // 取消结束工作
    handleCancelEnd_3(row) {
      ComponentStateUpdate(row.计划流水号, 4).then(response => {
        this.searchTable1()
        row.buttonStatus = 2
        // this.searchTable2()
      })
    },
    initProject() {
      initProject().then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.machineNumber.push({
            label: response.data[i].机床图号,
            name: response.data[i].项目名称,
            value: response.data[i].机床流水号
          })
        }
      })
    },
    machineChange() {
      this.groupNumberValue = ''
      this.groupNumber = []
      searchgroup(this.machineNumberValue).then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.groupNumber.push({
            label: response.data[i].组号,
            value: response.data[i].组件流水号
          })
        }
      })
    },
    searchTable1() {
      this.tableData1 = []
      if (this.machineNumberValue !== '' && this.machineNumberValue !== null) { this.check2 = 1 } else { this.check2 = 0 }
      if (this.check2 === 0) {
        this.tableData1 = []
        this.tableData2 = []
      } else {
        searchTable1(this.machineNumberValue, this.check2).then(response => {
          this.tableData1 = response.data
        }).then(() => {
          this.searchTable2()
        })
      }
    },
    searchTable2() {
      this.tableData2 = []
      if (this.machineNumberValue !== '' && this.machineNumberValue !== null) {
        this.check2 = 1
        searchTable2(this.machineNumberValue, 4).then(response => {
          console.log(response.data, 111)
          this.tableData2 = response.data
          this.tableData2.map(v => {
            this.$set(v, 'isEditing', false)
            this.$set(v, '原实际工时', '')
            this.$set(v, '原修补工时', '')
            this.$set(v, '原备注', '')
            if (v.是否工作 === null || v.是否工作 === 0) {
              this.$set(v, 'buttonStatus', 1)
            } else if (v.是否工作 === 1) {
              this.$set(v, 'buttonStatus', 2)
            } else {
              this.$set(v, 'buttonStatus', 3)
            }
            return v
          })
        })
      } else { this.check2 = 0 }
    },
    // 总装开始装配
    handlestart_1(row) { // 弹出单据编辑
      MachineToolStateUpdate(row.机床流水号, 1).then(response => {
        this.searchTable1()
        this.searchTable2()
      })
    },
    // 总装结束装配
    handleend_1(row) { // 弹出单据编辑
      MachineToolStateUpdate(row.机床流水号, 2).then(response => {
        this.searchTable1()
        this.searchTable2()
      })
    },
    // 总装开始调试
    handlestart_2(row) { // 弹出单据编辑
      DebugStatusUpdate(row.机床流水号, 1).then(response => {
        this.searchTable1()
        this.searchTable2()
      })
    },
    // 总装结束调试
    handleend_2(row) { // 弹出单据编辑
      DebugStatusUpdate(row.机床流水号, 2).then(response => {
        this.searchTable1()
        this.searchTable2()
      })
    },
    // 部装开始装配
    handlestart_3(row) { // 弹出单据编辑
      ComponentStateUpdate(row.计划流水号, 1).then(response => {
        this.searchTable1()
        row.buttonStatus = 2
        // this.searchTable2()
      })
    },
    // 部装结束装配
    handleend_3(row) { // 弹出单据编辑
      ComponentStateUpdate(row.计划流水号, 2).then(response => {
        this.searchTable1()
        row.buttonStatus = 3
        // this.searchTable2()
      })
    }
  }
}
</script>

<style scoped>

</style>
